/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ServStats.
 *
 * The Initial Developer of the Original Code is
 * George J. Lee <gjl@csail.mit.edu>
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var debug=false;

function dump(aMessage) {
  if (debug) {
    var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
    consoleService.logStringMessage("response.js: " + aMessage);
  }
}

function responseLoad() {
  var data = window.arguments[0];
  if (data == null) {
    this.dump("Warning, data is null.");
    return;
  }

  var keys = [
	      "lastSuccess",
	      "lastFailure",
	      "host",
	      "failureRate",
	      "avgLatency",
	      "conns",
	      "users"
	     ];

  for (var i=0; i<keys.length; i++ ) {
    var label = document.getElementById("diag-response-" + keys[i]);
    var newText = data[keys[i]];
    if (newText == null) {
      newText = '---';
    }
    label.setAttribute("value", newText);
  }
  var rows = document.getElementById("diag-response-status-rows");
  var statusList = new Array();
  for (var key in data.statusDist) {
    statusList.push(parseInt(key));
  }
  statusList.sort(function(a,b) { return a-b; });
  for (var i=0; i<statusList.length; i++) {
    var status = statusList[i];
    var valNode = document.getElementById("diag-response-status" + status);
    if (valNode == null) {
      this.dump("Warning, error code " + status + " not found, ignoring.");
    } else {
      valNode.setAttribute("value", data.statusDist[status]);
    }
  }

  // Remove rows with count 0
  var rowNodes = rows.getElementsByTagName("row");
  for (var i=rowNodes.length - 1; i>=0; i--) {
    var labels = rowNodes[i].getElementsByTagName("label");
    var val = parseInt(labels[1].getAttribute("value"));
    if (val == 0) {
      rows.removeChild(rowNodes[i]);
    }
  }
}

function responseUnload() {
}
